﻿using ScheduleCRUDSample.Models;
using System;
using System.Collections;
using System.Linq;
using System.Web.Mvc;

namespace ScheduleCRUDSample.Controllers
{
    public class HomeController : Controller
    {
        ScheduleDataDataContext db = new ScheduleDataDataContext();
        public ActionResult Index()
        {
            return View();
        }

        public JsonResult GetData()
        {
            IEnumerable data = new ScheduleDataDataContext().Appointments.Take(100); // nw.Appointment.Take(5);
            return Json(data, JsonRequestBehavior.AllowGet);
        }
       
        public JsonResult Batch(EditParams param)
        {
            if (param.action == "insert" || (param.action == "batch" && param.added != null))          // this block of code will execute while inserting the appointments
            {
                var value = param.action == "insert" ? param.value : param.added[0];
                //int intMax = db.Appointments.ToList().Count > 0 ? db.Appointments.ToList().Max(p => p.Id) : 1;
                DateTime startTime = Convert.ToDateTime(value.StartTime);
                DateTime endTime = Convert.ToDateTime(value.EndTime);
                var currentTimeZone = TimeZone.CurrentTimeZone;
                Appointment appoint = new Appointment()
                {
                    Id = value.Id,
                    StartTime = startTime,
                    EndTime = endTime,
                    Subject = value.Subject,
                    Description = value.Description,
                    Recurrence = value.Recurrence,
                    AllDay = value.AllDay,
                    RecurrenceRule = value.RecurrenceRule,
                };
                db.Appointments.InsertOnSubmit(appoint);
                db.SubmitChanges();
            }
            if (param.action == "remove" || param.deleted != null)                                        // this block of code will execute while removing the appointment
            {
                if (param.action == "remove")
                {
                    int key = Convert.ToInt32(param.key);
                    Appointment app = db.Appointments.Where(c => c.Id == key).FirstOrDefault();
                    if (app != null) db.Appointments.DeleteOnSubmit(app);
                }
                else
                {
                    foreach (var apps in param.deleted)
                    {
                        Appointment app = db.Appointments.Where(c => c.Id == apps.Id).FirstOrDefault();
                        if (apps != null) db.Appointments.DeleteOnSubmit(app);
                    }
                }
                db.SubmitChanges();
            }
            if ((param.action == "batch" && param.changed != null) || param.action == "update")   // this block of code will execute while updating the appointment
            {
                var value = param.action == "update" ? param.value : param.changed[0];
                var appId = Convert.ToInt32(value.Id);
                var filterData = db.Appointments.Where(c => c.Id == appId);

                if (filterData.Count() > 0)
                {
                    DateTime startTime = Convert.ToDateTime(value.StartTime);
                    DateTime endTime = Convert.ToDateTime(value.EndTime);
                    var AppId = Convert.ToInt32(value.Id);
                    Appointment appoint = db.Appointments.Single(A => A.Id == AppId);
                    appoint.StartTime = startTime;
                    appoint.EndTime = endTime;
                    appoint.Subject = value.Subject;
                    appoint.Description = value.Description;
                    appoint.Recurrence = Convert.ToByte(value.Recurrence);
                    appoint.AllDay = value.AllDay;
                    appoint.RecurrenceRule = value.RecurrenceRule;
                    
                }
                db.SubmitChanges();
            }
            IEnumerable data = db.Appointments.Take(100); // nw.Appointment.Take(5);
            return Json(data, JsonRequestBehavior.AllowGet);
        }
    }
}